import React,{Component} from 'react';
import {View,Icon} from '@tarojs/components'
import {getUserByName} from '../../utils/servers/servers';

import {AtSearchBar, AtListItem} from 'taro-ui'

import 'taro-ui/dist/style/components/search-bar.scss';
import 'taro-ui/dist/style/components/button.scss';
import 'taro-ui/dist/style/components/icon.scss';
import 'taro-ui/dist/style/components/list.scss';
import 'taro-ui/dist/style/components/icon.scss';

import ListBottomStart from '../../components/common/listBottomStart';

import Taro from '@tarojs/taro';

class Enterprise extends Component{
  constructor(props) {
    super(props);
    this.state={
      value:'',
      loading:false,
      data:[],
      listState:'NO_DATA',
      selectId:0,
    }
    this.onChange = this.onChange.bind(this);
  }

  onChange (value,lv=true) {
    this.setState({
      value,
    })
    if(value.length < 2 && !lv){
      Taro.showToast({title:'最少输入两个字符',icon:'none'})
      return
    }
    if(value.length < 4 && lv){return}
    this.setState({
      listState: 'LOADING'
    })
    getUserByName({
      name:value
    }).then((data)=>{
      if(data.error.length === 0){
        if(data.data.length === 0){
          this.setState({
            listState: 'NO_DATA'
          })
        }else{
          this.setState({
            listState: 'NO_MORE_DATA'
          })
        }
        this.setState({
          data:data.data
        })
      }else{
        this.setState({
          listState: data.error[0].field === '403' ? 'NO_DATA' : 'RELOAD'
        })
        Taro.showToast({
          title:data.error[0].message,
          icon:'none'
        })
      }
    }).catch(()=>{
      this.setState({
        listState: 'RELOAD'
      })
    })
  }

  componentWillUnmount() {
    this.setState({
      value:'',
      data:[],
      listState:'NO_DATA',
      selectId:0
    })
  }

  render() {
    return (
      <>
        <AtSearchBar
          showActionButton
          value={this.state.value}
          onChange={this.onChange}
          onActionClick={()=>{this.onChange(this.state.value,false)}}
          onClear={()=>{
            this.setState({
              value:'',
              data:[],
              listState:'NO_DATA',
              selectId:0
            },()=>{
              this.props.onChange({});
            })
          }}
        />
        <View>
          {
            this.state.data.map((v,k)=>(
              <View style={{
                padding:'10px',
                display:'flex',
                flexFlow:'row',
                alignItems:'center',
                justifyContent:'space-between',
                borderBottom:'1px #ece6e6 solid'
              }} key={k} onClick={()=>{
                this.setState({
                  selectId:v.id
                })
                this.props.onChange({uid:v.id,nickname:v.name});
              }}>
                <View style={{fontSize:'15px'}}>{v.name}</View>
                {this.state.selectId === v.id ? <Icon size='20' type='success_no_circle' /> : null}
              </View>
            ))
          }
          <ListBottomStart
            state={this.state.listState}
            reload={()=>{
              this.onChange(this.state.value)
            }}/>
        </View>
      </>
    )
  }
}

export default Enterprise;
